//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: random/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query creates service with guardian as rpc
///
/// Usage: instantiate `Irismod_Random_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Irismod_Random_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Irismod_Random_QueryClientInterceptorFactoryProtocol? { get }

  func random(
    _ request: Irismod_Random_QueryRandomRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Random_QueryRandomRequest, Irismod_Random_QueryRandomResponse>

  func randomRequestQueue(
    _ request: Irismod_Random_QueryRandomRequestQueueRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Irismod_Random_QueryRandomRequestQueueRequest, Irismod_Random_QueryRandomRequestQueueResponse>
}

extension Irismod_Random_QueryClientProtocol {
  internal var serviceName: String {
    return "irismod.random.Query"
  }

  /// Random queries the random result
  ///
  /// - Parameters:
  ///   - request: Request to send to Random.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func random(
    _ request: Irismod_Random_QueryRandomRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Random_QueryRandomRequest, Irismod_Random_QueryRandomResponse> {
    return self.makeUnaryCall(
      path: "/irismod.random.Query/Random",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRandomInterceptors() ?? []
    )
  }

  /// RandomRequestQueue queries the random request queue
  ///
  /// - Parameters:
  ///   - request: Request to send to RandomRequestQueue.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func randomRequestQueue(
    _ request: Irismod_Random_QueryRandomRequestQueueRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irismod_Random_QueryRandomRequestQueueRequest, Irismod_Random_QueryRandomRequestQueueResponse> {
    return self.makeUnaryCall(
      path: "/irismod.random.Query/RandomRequestQueue",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRandomRequestQueueInterceptors() ?? []
    )
  }
}

internal protocol Irismod_Random_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'random'.
  func makeRandomInterceptors() -> [ClientInterceptor<Irismod_Random_QueryRandomRequest, Irismod_Random_QueryRandomResponse>]

  /// - Returns: Interceptors to use when invoking 'randomRequestQueue'.
  func makeRandomRequestQueueInterceptors() -> [ClientInterceptor<Irismod_Random_QueryRandomRequestQueueRequest, Irismod_Random_QueryRandomRequestQueueResponse>]
}

internal final class Irismod_Random_QueryClient: Irismod_Random_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Irismod_Random_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the irismod.random.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Irismod_Random_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query creates service with guardian as rpc
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Irismod_Random_QueryProvider: CallHandlerProvider {
  var interceptors: Irismod_Random_QueryServerInterceptorFactoryProtocol? { get }

  /// Random queries the random result
  func random(request: Irismod_Random_QueryRandomRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Random_QueryRandomResponse>

  /// RandomRequestQueue queries the random request queue
  func randomRequestQueue(request: Irismod_Random_QueryRandomRequestQueueRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Irismod_Random_QueryRandomRequestQueueResponse>
}

extension Irismod_Random_QueryProvider {
  internal var serviceName: Substring { return "irismod.random.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Random":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Random_QueryRandomRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Random_QueryRandomResponse>(),
        interceptors: self.interceptors?.makeRandomInterceptors() ?? [],
        userFunction: self.random(request:context:)
      )

    case "RandomRequestQueue":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irismod_Random_QueryRandomRequestQueueRequest>(),
        responseSerializer: ProtobufSerializer<Irismod_Random_QueryRandomRequestQueueResponse>(),
        interceptors: self.interceptors?.makeRandomRequestQueueInterceptors() ?? [],
        userFunction: self.randomRequestQueue(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Irismod_Random_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'random'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRandomInterceptors() -> [ServerInterceptor<Irismod_Random_QueryRandomRequest, Irismod_Random_QueryRandomResponse>]

  /// - Returns: Interceptors to use when handling 'randomRequestQueue'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRandomRequestQueueInterceptors() -> [ServerInterceptor<Irismod_Random_QueryRandomRequestQueueRequest, Irismod_Random_QueryRandomRequestQueueResponse>]
}
